//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "bcbbkc.h"
#include "err.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cgauges"
#pragma resource "*.dfm"
TfmMain *fmMain;
//---------------------------------------------------------------------------
__fastcall TfmMain::TfmMain(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::Button2Click(TObject *Sender)
{
 char msg[50];
 TListItem  *ListItem;
 bool included;
 int Total=0;
 int t0,t1,t2;
 unsigned int TotalSize=0;
 AnsiString Path=DirectoryListBox1->Directory;
 AnsiString FileName,FileExt;
 struct ffblk ffblk;
 int done;

 ListView1->Items->Clear();
 if(Path.Length()>3) Path+='\\';
 FileName=Path+"*.*";
 done = findfirst(FileName.c_str(),&ffblk,0);
 while (!done)
   {
      included=false;
      FileExt=LowerCase(ExtractFileExt(ffblk.ff_name));
      if(CheckBox1->Checked && FileExt==".bpr") included=true;
      if(CheckBox2->Checked && (FileExt==".cpp" || FileExt==".c")) included=true;
      if(CheckBox3->Checked && (FileExt==".hpp" || FileExt==".h")) included=true;
      if(CheckBox4->Checked && FileExt==".dfm") included=true;
      if(CheckBox5->Checked && FileExt==".res") included=true;
      if(CheckBox6->Checked && FileExt==".rc") included=true;
      if(CheckBox8->Checked && FileExt==".bmp") included=true;
      if(CheckBox9->Checked && (FileExt==".ico" || FileExt==".icn")) included=true;
      if(CheckBox10->Checked && FileExt==".txt") included=true;
      if(CheckBox11->Checked && FileExt==LowerCase(Edit2->Text)) included = true;

      if(included)
       {
        ListItem=ListView1->Items->Add();
        ListItem->Caption=Path+ffblk.ff_name;
        ListItem->SubItems->Add(FormatFloat((AnsiString)"0.000", (float)ffblk.ff_fsize / 1024.0));
        TotalSize+=ffblk.ff_fsize;
        t0=ffblk.ff_fdate&0x1f;
        t1=(ffblk.ff_fdate>>5)&0xf;
        t2=((ffblk.ff_fdate>>9)&0x7f)+1980;
        sprintf(msg,"%d-%02d-%02d",t2,t1,t0);
        ListItem->SubItems->Add(msg);
        t0=(ffblk.ff_ftime&0x1f)*2;
        t1=(ffblk.ff_ftime>>5)&0x3f;
        t2=(ffblk.ff_ftime>>11)&0x1f;
        sprintf(msg,"%02d:%02d:%02d",t2,t1,t0);
        ListItem->SubItems->Add(msg);
        Total++;
       }
      done = findnext(&ffblk);
   }
  Label8->Caption=IntToStr(TotalSize)+" Bytes";
  Label6->Caption=AnsiString(Total);
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::Button1Click(TObject *Sender)
{
 AnsiString Dir=Edit1->Text;
 if(SelectDirectory(Dir,TSelectDirOpts()<<sdAllowCreate<<sdPerformCreate<<sdPrompt,1000))
   Edit1->Text=Dir;
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::Button3Click(TObject *Sender)
{
 int i;
 bool err=false;

 Panel2->Enabled=false;
 AnsiString ToFile,Dir=Edit1->Text;
 char *buf=new char[Dir.Length()+1];
 Screen->Cursor=crAppStart;
 strcpy(buf,Dir.c_str());
 if(buf[strlen(buf)-1]!='\\') Dir+='\\';
 delete buf;
 ProgressBar1->Max=ListView1->Items->Count;
 ProgressBar1->Position=0;
 fmErr->ListBox1->Clear();
 for(i=0;i<ListView1->Items->Count;i++)
  {
   ToFile=Dir+ExtractFileName(ListView1->Items->Item[i]->Caption);
   if(!CopyFile(ListView1->Items->Item[i]->Caption.c_str(),ToFile.c_str(),false))
     {
      fmErr->ListBox1->Items->Add(ExtractFileName(ListView1->Items->Item[i]->Caption));
      err=true;
      if(Application->MessageBox("Error!Continue?","BCB Backup",MB_YESNO)==IDNO) break;
     }
   ProgressBar1->Position=i;
   Application->ProcessMessages();
  }
  ProgressBar1->Position=0;
 Screen->Cursor=crDefault;
 if(err)fmErr->ShowModal();
 Panel2->Enabled=true;
}
//---------------------------------------------------------------------------


void __fastcall TfmMain::FormCreate(TObject *Sender)
{

 SystemPath=ExtractFilePath(Application->ExeName);
// if(!SystemPath.IsPathDelimiter(SystemPath.Length()-1)) SystemPath+='\\';
 TIniFile *IniFile=new TIniFile(SystemPath+"bcbbk.ini");
 Edit1->Text=IniFile->ReadString("DestPath","Path","");
 DirectoryListBox1->Directory=IniFile->ReadString("SourcePath","Path","");
 Edit2->Text=IniFile->ReadString("Edit2","Text","");
 CheckBox1->Checked=IniFile->ReadBool("Options","CheckBox1",true);
 CheckBox2->Checked=IniFile->ReadBool("Options","CheckBox2",true);
 CheckBox3->Checked=IniFile->ReadBool("Options","CheckBox3",true);
 CheckBox4->Checked=IniFile->ReadBool("Options","CheckBox4",true);
 CheckBox5->Checked=IniFile->ReadBool("Options","CheckBox5",true);
 CheckBox6->Checked=IniFile->ReadBool("Options","CheckBox6",true);
 CheckBox7->Checked=IniFile->ReadBool("Options","CheckBox7",false);
 CheckBox8->Checked=IniFile->ReadBool("Options","CheckBox8",false);
 CheckBox9->Checked=IniFile->ReadBool("Options","CheckBox9",false);
 CheckBox10->Checked=IniFile->ReadBool("Options","CheckBox10",false);
 CheckBox11->Checked=IniFile->ReadBool("Options","CheckBox11",false);

 delete IniFile;
}
//---------------------------------------------------------------------------





void __fastcall TfmMain::ShowSelectedFiles1Click(TObject *Sender)
{
 ListView1->Visible=true;         
}
//---------------------------------------------------------------------------


void __fastcall TfmMain::Exit1Click(TObject *Sender)
{
 Close();        
}
//---------------------------------------------------------------------------



void __fastcall TfmMain::CoolBar1DockOver(TObject *Sender,
      TDragDockObject *Source, int X, int Y, TDragState State,
      bool &Accept)
{
 if(Source->Control==ListView1) Accept=false;        
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::FormClose(TObject *Sender, TCloseAction &Action)
{
  AnsiString s=ExtractFilePath(Application->ExeName)+"bcbbk.ini";
  TIniFile *IniFile=new TIniFile(s);
 IniFile->WriteString("DestPath","Path",Edit1->Text);
 IniFile->WriteString("SourcePath","Path",DirectoryListBox1->Directory);
 IniFile->WriteString("Edit2","Text",Edit2->Text);
 IniFile->WriteBool("Options","CheckBox1",CheckBox1->Checked);
 IniFile->WriteBool("Options","CheckBox2",CheckBox2->Checked);
 IniFile->WriteBool("Options","CheckBox3",CheckBox3->Checked);
 IniFile->WriteBool("Options","CheckBox4",CheckBox4->Checked);
 IniFile->WriteBool("Options","CheckBox5",CheckBox5->Checked);
 IniFile->WriteBool("Options","CheckBox6",CheckBox6->Checked);
 IniFile->WriteBool("Options","CheckBox7",CheckBox7->Checked);
 IniFile->WriteBool("Options","CheckBox8",CheckBox8->Checked);
 IniFile->WriteBool("Options","CheckBox9",CheckBox9->Checked);
 IniFile->WriteBool("Options","CheckBox10",CheckBox10->Checked);
 IniFile->WriteBool("Options","CheckBox11",CheckBox11->Checked);

 delete IniFile;        
}
//---------------------------------------------------------------------------

